$(document).ready(function () {
    $("body").on("blur", ".barcode", itemModalShow);
    $(".iTbody").on("click", ".itemTr", addTrVal);
    $(".itemModal").on("keyup", ".isearch", getItemData);
    $(".itemModal").on("change", ".isortBy, iorderAS", getItemData);
    $(".inoRecord").hide();

    window.addEventListener('keydown', function (e) {
        if (e.keyIdentifier == 'U+000A' || e.keyIdentifier == 'Enter' || e.keyCode == 13) {
            if (e.target.nodeName == 'INPUT' && e.target.type == 'text' && e.target.className == "iprodname") {
                addTrVal(e);
                event.preventDefault();
            }
        }
    }, true);

    function itemModalShow() {
        var tr = $(this).closest("tr"),
                srno = tr.find(".srno").val(),
                party = $(".cmbparty").val(),
                file = $(".file").val(),
                godown = $(".godown").val(),
                margin = srno * 2.5,
                barcode = tr.find(".barcode").val(),
                itemcode = tr.find(".itemcode").val();
        $(".modal-content").css("margin-top", margin + "%")

        if (barcode == "") {
            $(".srno").removeClass("dataSrno");
            $(".barcode").removeClass("dataBarcode");
            $(".itemcode").removeClass("dataItemcode");
            $(".prodtype").removeClass("dataProdtype");
            $(".brand").removeClass("dataBrand");
            $(".prodname").removeClass("dataProdname");
            $(".quality").removeClass("dataQuality");
            $(".qty").removeClass("dataQty");
            $(".hsncode").removeClass("dataHsncode");
            $(".stqty").removeClass("dataStkQty");
            $(".unit").removeClass("dataUnit");

            tr.find(".prodname").addClass("dataProdname");
            tr.find(".prodtype").addClass("dataProdtype");
            tr.find(".barcode").addClass("dataBarcode");
            tr.find(".itemcode").addClass("dataItemcode");
            tr.find(".brand").addClass("dataBrand");
            tr.find(".unit").addClass("dataUnit");
            tr.find(".size").addClass("dataSize");
            tr.find(".quality").addClass("dataQuality");
            tr.find(".qty").addClass("dataQty");
            tr.find(".hsncode").addClass("dataHsncode");
            tr.find(".stqty").addClass("dataStkQty");
            tr.find(".unit").addClass("dataUnit");

            $(".itemModal").modal("show");
            getItemData();
        } else {
            $.ajax({
                type: "POST",
                datatype: "json",
                url: "search_ibarcode.php",
                data: {barcode: barcode, itemcode: itemcode, party: party, file: file, godown: godown},
                success: function (response) {
                    var m = response;
                    
                    tr.find(".prodname").val(m.prodname);
                    tr.find(".barcode").val(m.barcode);
                    tr.find(".itemcode").val(m.itemcode);
                    tr.find(".prodtype").val(m.prodtype);
                    tr.find(".brand").val(m.brand);
                    tr.find(".size").val(m.size);
                    tr.find(".quality").val(m.quality);
                    tr.find(".unit").val(m.unit);
                    tr.find(".hsncode").val(m.hsncode);
                    tr.find(".stqty").val(m.stkqty);
                    tr.find(".qty").focus();
                    tr.find(".qty").select();
                },
                error: function (request, textStatus, errorThrown) {

                }
            });
        }
    }

    $(".itemModal").on('shown.bs.modal', function () {
        $(".isearch").focus();
        $(".isearch").val("");
        $(".ifield").val("1");
        getItemData();
    });

    $(".itemModal").on('hidden.bs.modal', function () {
        $(".dataQty").focus();
//        $(".qty").focus();
        $(".dataQty").select();
    });

    var imrangeFrom = 0,
            imrangeTo = 40;

    function getItemData(pagination) {

        $(".iloader").show();

        if (pagination == 'prev') {
            if (imrangeFrom > 0) {
                imrangeFrom = (imrangeFrom - 40);
                imrangeTo = (imrangeTo - 40);
            }
        }
        if (pagination == 'next') {
            imrangeFrom = (imrangeFrom + 40);
            imrangeTo = (imrangeTo + 40);
        }

        var vouchno = $(".vouchno").val(),
                file = $(".file").val(),
                isearch = $(".isearch").val(),
                ifield = $(".ifield").val(),
                ioperator = $(".ioperator").val(),
                sortBy = $(".isortBy").val(),
                orderAs = $(".iorderBy").val(),
                party = $(".cmbparty").val(),
                godown = $(".godown").val(),
                data = {isearch: isearch, ifield: ifield, ioperator: ioperator, sortBy: sortBy, orderAs: orderAs,
                    vouchno: vouchno, file: file, rangeFrom: imrangeFrom, rangeTo: imrangeTo, party: party, godown: godown},
                values = "";
        $.ajax({
            type: 'GET',
            dataType: 'json',
            url: "search_item.php",
            data: data,
            success: function (response) {
                $.each(response, function () {
                    values += "<tr class='itemTr'>" +
//                            "<td align='left'><input type='text' class='itemcode' value='" + this.itemcode + "' readonly style='width:100%'tabindex='-1'></td>" +
                            "<td align='left'><input type='text' class='iprodname' value='" + this.prodname + "' readonly style='width:100%' ></td>" +
                            "<td align='left'><input type='text' class='isize' value='" + this.size + "' readonly style='width:100%'  tabindex='-1'></td>" +
                            "<td align='left'><input type='text' class='ibrand' value='" + this.brand + "' readonly style='width:100%' tabindex='-1'></td>" +
                            "<td align='left'><input type='text' class='iquality' value='" + this.quality + "' readonly style='width:100%' tabindex='-1'></td>" +
                            "<td align='left'><input type='text' class='icode' value='" + this.code + "' readonly style='width:100%' tabindex='-1'></td>" +
                            "<td align='left'><input type='text' class='istkqty' value='" + this.stkqty + "' readonly style='width:100%' tabindex='-1'>\n\
                             <input type='hidden' class='ihsncode' value='" + this.hsncode + "' readonly style='width:100%'tabindex='-1'>\n\
                             <input type='hidden' class='iunit' value='" + this.unit + "' readonly style='width:100%'tabindex='-1'></td>" +
                            "<td align='left'><input type='text' class='iprodtype' value='" + this.prodtype + "' readonly style='width:100%'></td>" +
                            "</tr>";
                });
                $(".iloader").hide();
                $(".iTbody").empty();
                $(".iTbody").html(values);
                if (response) {
                    $(".search-action-bar").show();
                }
            },
            error: function (request, textStatus, errorThrown) {

            }
        });
    }
    $(".iload").click(function () {
        getItemData();
    });
//    $(".isearch").change(function () {
//        getItemData();
//    });
    $(".iprevious").click(function () {
        getItemData('prev');
    });
    $(".inext").click(function () {
        getItemData('next');
    });

    function addTrVal(e) {
        var tr = "";
        if (e == "undefined") {
            tr = $(this).closest("tr");
        } else {
            tr = $(e.target).closest("tr");
        }

        var iprodname = tr.find(".iprodname").val(),
                icode = tr.find(".icode").val(),
                itemcode = tr.find(".itemcode").val(),
                ibrand = tr.find(".ibrand").val(),
                isize = tr.find(".isize").val(),
                iunit = tr.find(".iunit").val(),
                ihsncode = tr.find(".ihsncode").val(),
                iquality = tr.find(".iquality").val(),
                iprodtype = tr.find(".iprodtype").val(),
                istkqty = tr.find(".istkqty").val();



        $(".dataProdname").val(iprodname);
        $(".dataBarcode").val(icode);
        $(".dataItemcode").val(itemcode);
        $(".dataBrand").val(ibrand);
        $(".dataUnit").val(iunit);
        $(".dataHsncode").val(ihsncode);
        $(".dataSize").val(isize);
        $(".dataQuality").val(iquality);
        $(".dataStkQty").val(istkqty);
        $(".dataProdtype").val(iprodtype);


        $(".dataProdname").removeClass('dataProdname');
        $(".dataBarcode").removeClass('dataBarcode');
        $(".dataItemcode").removeClass('dataItemcode');
        $(".dataBrand").removeClass("dataBrand");
        $(".dataUnit").removeClass("dataUnit");
        $(".dataHsncode").removeClass("dataHsncode");
        $(".dataSize").removeClass("dataSize");
        $(".dataQuality").removeClass("dataQuality");
        $(".dataRate").removeClass("dataRate");
        $(".dataProdtype").removeClass("dataProdtype");
        $(".dataStkQty").removeClass("dataStkQty");
        $(".itemModal").modal("hide");
//        $(".dataQty").focus();
        $(".qty").focus();
        $(".qty").select();

    }


    $(".qty").blur(function () {
        $(".dataQty").removeClass("dataQty");
    });
});